package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.openqa.selenium.Keys;
import org.openqa.selenium.WebElement;
import org.openqa.selenium.interactions.Actions;

public class DistribuicaodaRefeicaoPage extends PageBase {
    By menubutton = By.xpath("//*[@class='bars']");
    By campopesquisar = By.xpath("//section[@class='zh-container-search-menu']//input[@type='text']");
    By distribuicaodarefeicaobutton = By.xpath("//span[text()='Distribuição da Refeição']");

    // DISTRIBUIÇÃO MANUAL
    By distibuicaomanualfield = By.xpath("//span[text()='Distribuição Manual']");
    By campodescricaofield = By.id("DSDISTRIBREFEICAO");
    By campodatainiciofield = By.id("DTINTERVAL_START");
    By campodatafimfield = By.id("DTINTERVAL_END");
    By campofiltrarfield = By.xpath("//span[text()='Filtrar']");

    // GERAR NOVO - DISTRIBUIÇÃO
    By campodedatainiciofield = By.id("DTINTERVAL_START");
    By campodedatafimfield = By.id("DTINTERVAL_END");
    By lupaunidadeagregada = By.xpath("//*[@id='FILIAGREGA']//span[@class='right-search zh-ripple-effect zh-icon zh-icon-search zh-icon-no-border']");
    By unidadeagregadabutton = By.xpath("//span[text()='DEPOSITO BC 111']");
    By campookconfirmaragregadabutton = By.xpath("//span[text()='Ok']");
    By lupacampodeservico = By.xpath("//*[@id='NMSERVICO']//span[@class='right-search zh-ripple-effect zh-icon zh-icon-search zh-icon-no-border']");
    By selecionarservicobutton = By.xpath("//span[text()='ALMOÇO']");
    By campofiltrarfield1 = By.xpath("//span[text()='Filtrar']");

    // SELECIONAR DISTRIBUIÇÃO
    By clicarselecionargerarnovofield = By.xpath("//span[text()='Gerar novo']");
    By selecionardistribuicaofield = By.xpath("//*[@id='NRDISTPROD']//span[@class='zh-icon zh-icon-search zh-icon-no-border']");
    By clicarnadistribuicaofield = By.xpath("//span[text()='3']");
    By campofiltrar2 = By.xpath("//span[text()='Filtrar']");

    // DEMAIS AÇÕES NA TELA
    By selecionarprodutodistribuicaobutton = By.xpath("//span[text()='BARATA ORIENTAL']");
    By selecionaragregadanavegandoentreacoes = By.xpath("//span[text()='01/09/2022']");
    By selecionarquantidadenagevandoentreacoes = By.xpath("//span[text()='119']");
    By editarinformacoesdistribuicaoprodutobutton = By.xpath("//*[@data-zh-id=\"6099770511122271440448\"]");
    By editarquantidadecomensaisfield = By.id("QTCOMENSAIS");
    By editarquantidadeporpessoafield = By.id("QTPORPESSOA");
    By editarquantidadedopratofield = By.id("QTPRATO");
    By lupaselecionarembalagem = By.xpath("//*[@id='NMCONTAINER']//span[@class='zh-icon zh-icon-search zh-icon-no-border']");
    By selecionarembalagemfield = By.xpath("//div[@id=\"grid-9000\"]//div[@data-zh-field-name=\"NMCONTAINER\"]//span[text() = 'VIDRO']");
    By adicionaragrupamentofield = By.id("CDAGRUPEMB");
    By salvaredicodistribuicao = By.xpath("//span[text()='Salvar']");
    By campovoltarfield = By.xpath("//span[text()='Voltar']");
    By campoefetivacaoproduto = By.xpath("//*[@data-zh-id=\"6099770513609258133583\"]");
    By confirmaefetivacaobutton = By.xpath("//span[text()='Efetivar']");
    By confirmardataefetivacaobutton = By.xpath("//span[text()='Efetivar']");
    By distribuicaodataanteriorbutton = By.xpath("//span[text()='Sim']");
    By efetivacaorealizada = By.xpath("//section[@class='zh-container-alert']//p[@class='zh-text-alert']");


    By calcularembalagembutton = By.xpath("//*[@data-zh-id=\"6099770514201828134220\"]");
    By botaookcalcularembalagem = By.xpath("//span[text()='OK']");

    // OPÇÃO DE ADICIONAR NOVO PRODUTO
    By campoadicionarbutton = By.xpath("//*[@data-zh-id=\"6099770512277713059499\"]");
    By lupaagregadaadicionarbutton = By.xpath("//*[@id='CDFILIAL']//span[@class='right-search zh-ripple-effect zh-icon zh-icon-search zh-icon-no-border']");
    By selecionaragregadafiltroadicionarfield = By.xpath("//span[text()='DEPOSITO BC 111']");
    By botaookselecionadoagregada = By.xpath("//span[text()='Ok']");
    By botaofiltrar = By.xpath("//span[text()='Filtrar']");
    By lupaadicionarproduto = By.xpath("//*[@id='NMPRODUTO']//span[@class='zh-icon zh-icon-search zh-icon-no-border']");
    By selecionarproduto = By.xpath("//span[text()='OLEO DE CASTANHA DO BRASIL']");
    By selecionarunidadefield = By.xpath("//span[text()='ALMOÇO']");
    By confirmarbutton = By.xpath("//*[@data-zh-id=\"6099770511870741846488\"]");
    By salvaralteracoes = By.xpath("//span[text()='Salvar alterações']");
    By excluirprodutobutton = By.xpath("//span[text()='Excluir']");
    By simconfirmarexclusaobutton = By.xpath("//span[text()='Sim']");

    //EFETIVAR DISTRIBUIÇÃO
    By selecionarprodutobutton = By.xpath("//*[@class='td grid-checkbox-column zh-side-column fixed zh-ripple-effect']//span[@data-ng-if='!row.__group']");
    By efetivacaoprodutobutton = By.xpath("//*[@data-zh-id=\"6099770513609258133583\"]");
    By opcaoefetivarbutton = By.xpath("//span[text()='Efetivar']");
    By botaosimconfirmarefetivacao = By.xpath("//span[text()='Sim']");
    By confirmardataefetivacao = By.xpath("//span[text()='Efetivar']");
    By efetivacaocomdataanteriorconfirmar = By.xpath("//span[text()='Sim']");
    By botaookefetivacaorealizada = By.xpath("//span[text()='OK']");

    // AÇÕES
    By acoesbutton = By.xpath("//span[text()='Ações']");
    By efetivardistribuicaobutton = By.xpath("//span[text()='Efetivar Distribuição']");
    By cancelardistribuicaobutton = By.xpath("//span[text()='Cancelar Distribuição']");
    By cancelarefetivacaobutton = By.xpath("//span[text()='Cancelar Efetivação']");


    //Actions
    public void AcessarTela() {
        try {
            Thread.sleep(5000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        click(menubutton);
        sendKeys(campopesquisar, "Distribuição da Refeição");
        click(distribuicaodarefeicaobutton);
    }


    public void DistribuicaoManual(String descricao, String datainicio, String datafim){
        click(distibuicaomanualfield);
        click(campodescricaofield);
        sendKeys(campodescricaofield,descricao);
        clear(campodatainiciofield);
        sendKeys(campodatainiciofield,datainicio);
        clear(campodatafimfield);
        sendKeys(campodatafimfield,datafim);
        click(campofiltrarfield);
    }

    public void NovaDistribuicao(String dataini, String dataf){
        clear(campodedatainiciofield);
        sendKeys(campodedatainiciofield,dataini);
        clear(campodedatafimfield);
        sendKeys(campodedatafimfield,dataf);
        click(lupaunidadeagregada);
        click(unidadeagregadabutton);
        click(campookconfirmaragregadabutton);
        click(lupacampodeservico);
        click(selecionarservicobutton);
        click(campofiltrarfield1);
    }

    public void Adicionarproduto(){
        click(campoadicionarbutton);
        click(lupaagregadaadicionarbutton);
        click(selecionaragregadafiltroadicionarfield);
        click(botaookselecionadoagregada);
        try {
            Thread.sleep(2000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        click(botaofiltrar);
        click(lupaadicionarproduto);
        click(selecionarproduto);
        click(selecionarunidadefield);
        click(confirmarbutton);
        click(salvaralteracoes);
        click(excluirprodutobutton);
        click(simconfirmarexclusaobutton);
    }

    public void AcoesEetivarDistribuicao(){
        click(acoesbutton);
        click(efetivardistribuicaobutton);
    }

    public void AcoesCancelarDistribuicao(){
        click(acoesbutton);
        click(cancelardistribuicaobutton);
    }

    public void AcoesCancelarEfetivacao(){
        click(acoesbutton);
        click(cancelarefetivacaobutton);
    }

    public void CalcularEmbalagem(){
        click(calcularembalagembutton);
        click(botaookcalcularembalagem);
    }

    public void SelecionarDistribuicao(){
        click(clicarselecionargerarnovofield);
        click(selecionardistribuicaofield);
        click(clicarnadistribuicaofield);
        click(campofiltrar2);
    }

    public void NavegarPelasAcoes(String comensais, String quantidadepessoa, String quantidadedoprato, String agropunidade){
        click(selecionarprodutodistribuicaobutton);
        click(selecionaragregadanavegandoentreacoes);
        click(selecionarquantidadenagevandoentreacoes);
        click(editarinformacoesdistribuicaoprodutobutton);
        click(editarquantidadecomensaisfield);
        sendKeys(editarquantidadecomensaisfield,comensais);
        click(editarquantidadeporpessoafield);
        sendKeys(editarquantidadeporpessoafield, quantidadepessoa);
        click(editarquantidadedopratofield);
        sendKeys(editarquantidadedopratofield, quantidadedoprato);
        click(lupaselecionarembalagem);
        try {
            Thread.sleep(3000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        click(selecionarembalagemfield);
        click(adicionaragrupamentofield);
        sendKeys(adicionaragrupamentofield, agropunidade);
        click(salvaredicodistribuicao);
        click(campovoltarfield);
        click(campovoltarfield);
        click(campovoltarfield);
        click(campoefetivacaoproduto);
        click(confirmaefetivacaobutton);
        click(confirmardataefetivacaobutton);
    }

    public void efetivardistribuicao(){
        click(selecionarprodutobutton);
        click(efetivacaoprodutobutton);
        click(opcaoefetivarbutton);
        click(botaosimconfirmarefetivacao);
        click(confirmardataefetivacao);
        click(efetivacaocomdataanteriorconfirmar);
    }

    public void Okefetivacaoconcluida(){
        click(botaookefetivacaorealizada);
    }


    public String efetivacaorealiz(){
        return getText(efetivacaorealizada);
    }




}
